com.fasterxml.jackson.jaxrs.cfg

## Enum JaxRSFeature

- java.lang.Object
- - java.lang.Enum<JaxRSFeature>
  - - com.fasterxml.jackson.jaxrs.cfg.JaxRSFeature

- All Implemented Interfaces:
    com.fasterxml.jackson.databind.cfg.ConfigFeature, Serializable, Comparable<JaxRSFeature>

      public enum JaxRSFeature
      extends Enum<JaxRSFeature>
      implements com.fasterxml.jackson.databind.cfg.ConfigFeature

  Enumeration that defines simple on/off features that can be used on all Jackson JAX-RS providers, regardless of underlying data format.

- - ### Enum Constant Summary

    Enum Constants
    Enum Constant and Description
    `ADD_NO_SNIFF_HEADER` Feature that can be enabled to make provider automatically add "nosniff" (see this entry for details
    `ALLOW_EMPTY_INPUT` Feature related to Issue #49: whether empty input is considered legal or not.
    `CACHE_ENDPOINT_READERS` [jaxrs-providers#86]: Feature that determines whether provider will cache endpoint definitions for reading or not (including caching of actual `ObjectReader` to use).
    `CACHE_ENDPOINT_WRITERS` [jaxrs-providers#86]: Feature that determines whether provider will cache endpoint definitions for writing or not (including caching of actual `ObjectWriter` to use).
    `DYNAMIC_OBJECT_MAPPER_LOOKUP` Feature that may be enabled to force dynamic lookup of `ObjectMapper` via JAX-RS Provider interface, regardless of whether `MapperConfigurator`has explicitly configured mapper or not; if disabled, static configuration will take precedence.``

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `static int` | `collectDefaults()`
    `boolean` | `enabledByDefault()`
    `boolean` | `enabledIn(int flags)`
    `int` | `getMask()`
    `static JaxRSFeature` | `valueOf(String name)` Returns the enum constant of this type with the specified name.
    `static JaxRSFeature[]` | `values()` Returns an array containing the constants of this enum type, in the order they are declared.

    - ### Methods inherited from class java.lang.Enum

      `clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Enum Constant Detail

    - #### ALLOW_EMPTY_INPUT

          public static final JaxRSFeature ALLOW_EMPTY_INPUT

      Feature related to Issue #49: whether empty input is considered legal or not. If set to true, empty content is allowed and will be read as Java 'null': if false, an `IOException` will be thrown.

      NOTE: in case of JAX-RS 2.0, specific exception will be `javax.ws.rs.core.NoContentException`; but this is not defined in JAX-RS 1.x.

    - #### ADD_NO_SNIFF_HEADER

          public static final JaxRSFeature ADD_NO_SNIFF_HEADER

      Feature that can be enabled to make provider automatically add "nosniff" (see this entry for details

      Feature is disabled by default.

    - #### DYNAMIC_OBJECT_MAPPER_LOOKUP

          public static final JaxRSFeature DYNAMIC_OBJECT_MAPPER_LOOKUP

      Feature that may be enabled to force dynamic lookup of `ObjectMapper` via JAX-RS Provider interface, regardless of whether `MapperConfigurator`has explicitly configured mapper or not; if disabled, static configuration will take precedence. Note that if this feature is enabled, it typically makes sense to also disable `CACHE_ENDPOINT_READERS` and `CACHE_ENDPOINT_WRITERS` since caching would prevent lookups.

      Feature is disabled by default.

      ``
      Since:
        2.8

    - #### CACHE_ENDPOINT_READERS

          public static final JaxRSFeature CACHE_ENDPOINT_READERS

      [jaxrs-providers#86]: Feature that determines whether provider will cache endpoint definitions for reading or not (including caching of actual `ObjectReader` to use). Feature may be disabled if reconfiguration or alternate isntance of `ObjectMapper` is needed.

      Note that disabling of the feature may add significant amount of overhead for processing.

      Feature is enabled by default.

      Since:
        2.8

    - #### CACHE_ENDPOINT_WRITERS

          public static final JaxRSFeature CACHE_ENDPOINT_WRITERS

      [jaxrs-providers#86]: Feature that determines whether provider will cache endpoint definitions for writing or not (including caching of actual `ObjectWriter` to use). Feature may be disabled if reconfiguration or alternate isntance of `ObjectMapper` is needed.

      Note that disabling of the feature may add significant amount of overhead for processing.

      Feature is enabled by default.

      Since:
        2.8

  - ### Method Detail

    - #### values

          public static JaxRSFeature[] values()

      Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

          for (JaxRSFeature c : JaxRSFeature.values())
              System.out.println(c);

      Returns:
        an array containing the constants of this enum type, in the order they are declared

    - #### valueOf

          public static JaxRSFeature valueOf(String name)

      Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
      Parameters:
        `name` - the name of the enum constant to be returned.
      Returns:
        the enum constant with the specified name
      Throws:
        `IllegalArgumentException` - if this enum type has no constant with the specified name
        `NullPointerException` - if the argument is null

    - #### collectDefaults

          public static int collectDefaults()

    - #### enabledByDefault

          public boolean enabledByDefault()

      Specified by:
        `enabledByDefault` in interface `com.fasterxml.jackson.databind.cfg.ConfigFeature`

    - #### getMask

          public int getMask()

      Specified by:
        `getMask` in interface `com.fasterxml.jackson.databind.cfg.ConfigFeature`

    - #### enabledIn

          public boolean enabledIn(int flags)

      Specified by:
        `enabledIn` in interface `com.fasterxml.jackson.databind.cfg.ConfigFeature`

Copyright © 2016 FasterXML. All rights reserved.